/bamboohr-time | Type: Application | PCID required: Yes
Tools
bamboohr_time_adjust_time_off_balance
Adjust Time Off Balance Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
employeeId | integer | Yes | — | The ID of the employee. |
amount | number | No | — | The number of hours/days to adjust the balance by. |
date | string | No | — | The date the adjustment should be added in history. Should be in ISO8601 date format (YYYY-MM-DD). |
note | string | No | — | This is an optional note to show in history. |
timeOffTypeId | integer | No | — | The ID of the time off type to add a balance adjustment for. |
bamboohr_time_assign_employees_to_break_policy
Assign Employees to Break Policy Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The break policy ID. |
employeeIds | integer[] | Yes | — | Array of employee IDs to assign to the break policy |
bamboohr_time_assign_time_off_policies
Assign Time Off Policies Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
employeeId | integer | Yes | — | The ID of the employee to assign policies to. |
body | object[] | Yes | — | Request body |
bamboohr_time_assign_time_off_policies_v1_1
Assign Time Off Policies v1.1 Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
employeeId | integer | Yes | — | The ID of the employee to assign policies to. |
body | object[] | Yes | — | Request body |
bamboohr_time_create_break
Create Break Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The break policy ID. |
availabilityEndTime | string | No | — | Latest time the break can be taken (HH:MM format) |
availabilityMaxHoursWorked | number | No | — | Maximum hours that can be worked before the break must be taken |
availabilityMinHoursWorked | number | No | — | Minimum hours that must be worked before the break can be taken |
availabilityStartTime | string | No | — | Earliest time the break can be taken (HH:MM format) |
availabilityType | object | No | — | When the break is available to be taken |
duration | integer | No | — | Duration of the break in minutes |
name | string | No | — | The name of the break |
paid | boolean | No | — | Whether the break is paid |
policyId | string | No | — | The unique identifier of the break policy this break belongs to |
bamboohr_time_create_break_policy
Create Break Policy Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
allEmployeesAssigned | boolean | No | — | Whether all employees are assigned to this break policy |
breaks | object[] | No | — | Collection of time tracking breaks to create or update without a policy |
description | string | No | — | Optional description of the break policy |
employeeIds | integer[] | No | — | The employees that should be assigned to this policy |
name | string | Yes | — | Name of the break policy |
bamboohr_time_create_or_update_time_tracking_hour_records
Create or Update Hour Records Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
body | object[] | Yes | — | Request body |
bamboohr_time_create_or_update_timesheet_clock_entries
Create or Update Timesheet Clock Entries Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
entries | object[] | Yes | — | Array of clock entries |
bamboohr_time_create_or_update_timesheet_hour_entries
Create or Update Timesheet Hour Entries Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
hours | object[] | Yes | — | Array of hour entries to add or update |
bamboohr_time_create_time_off_history
Create Time Off History Item Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
employeeId | integer | Yes | — | The ID of the employee. |
amount | number | No | — | The number of hours/days to record. Required when eventType is override. |
date | string | No | — | The date for the history item in YYYY-MM-DD format. |
eventType | string | No | — | The type of history event. Defaults to used for the /history path and override for the /balance_adjustment path when omitted. |
note | string | No | — | An optional note to show in history. |
timeOffRequestId | integer | No | — | The ID of an approved time off request. Required when eventType is used. |
timeOffTypeId | integer | No | — | The ID of the time off type. Required when eventType is override. |
bamboohr_time_create_time_off_request
Create Time Off Request Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
employeeId | integer | Yes | — | The ID of the employee to create the time off request for. |
amount | number | No | — | Total hours or days requested. Ignored when dates array is provided (sum of daily amounts is used instead). |
dates | object[] | No | — | Optional per-day breakdown. When provided, the top-level amount is ignored and the sum of daily amounts is used. |
end | string | No | — | End date in YYYY-MM-DD format. Must be on or after the start date. |
notes | object[] | No | — | Optional notes from the employee or manager. |
previousRequest | integer | No | — | The ID of a previous time off request to supersede. The previous request will be cancelled. |
start | string | No | — | Start date in YYYY-MM-DD format. |
status | string | No | — | The initial status of the request. |
timeOffTypeId | integer | No | — | The ID of the time off type for this request. |
bamboohr_time_create_time_tracking_hour_record
Create Hour Record Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
dateHoursWorked | string | Yes | — | The date the hours were worked. Please use the ISO-8601 date format YYYY-MM-DD. |
departmentId | integer | No | — | [Optional] The ID of the department for the employee. |
divisionId | integer | No | — | [Optional] The ID of the division for the employee. |
employeeId | integer | Yes | — | The ID of the employee. |
hoursWorked | number | Yes | — | The number of hours worked. |
jobCode | integer | No | — | [Optional] A job code. |
jobData | string | No | — | [Optional] A list of up to four 20 characters max job numbers in comma delimited format with no spaces. |
jobTitleId | integer | No | — | [Optional] The ID of the job title for the employee. |
payCode | string | No | — | [Optional] Only necessary if the payroll provider requires a pay code |
payRate | number | No | — | [Optional] The rate of pay. e.g. $15.00/hour should use 15.00 here. Only necessary if the payroll provider requires a pay rate. |
rateType | string | Yes | — | The type of hours - regular or overtime. Please use either “REG”, “OT”, or “DT” here. |
timeTrackingId | string | Yes | — | A unique identifier for the record. Use this ID to adjust or delete these hours. It can be any ID you use to track the record up to 36 characters in length. (i.e. UUID). |
bamboohr_time_create_time_tracking_project
Create Time Tracking Project Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
allowAllEmployees | boolean | No | — | Indicates if all employees can log time for this project. Defaults to true if not provided. |
billable | boolean | No | — | Indicates if the project is billable. Defaults to true if not provided. |
employeeIds | integer[] | No | — | A list of employee IDs that can log time for this project. Only used when allowAllEmployees is false. |
hasTasks | boolean | No | — | Indicates if the project has tasks. Defaults to false if not provided. |
name | string | Yes | — | Name of the project. Must be unique and no more than 50 characters. |
tasks | object[] | No | — | List of tasks to create and associate with the project. |
bamboohr_time_create_timesheet_clock_in_entry
Create Timesheet Clock-In Entry Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
employeeId | integer | Yes | — | ID of the employee to clock in. |
breakId | string | No | — | ID of the break that should be associated with the timesheet entry. |
date | string | No | — | Date for the timesheet entry. Must be in YYYY-MM-DD format. |
note | string | No | — | The note that should be associated with the timesheet entry |
offline | boolean | No | — | Whether this is an offline punch. When true, bypasses the shift schedule clock-in restriction. Intended for devices that store punches offline and sync later. |
projectId | integer | No | — | ID of the time tracking project that should be associated with the timesheet entry. Required if taskId is specified. |
start | string | No | — | The time for the clock in. In 24 hour format HH:MM |
taskId | integer | No | — | ID of the time tracking task that should be associated with the timesheet entry. |
timezone | string | No | — | The timezone associated with the clock in. |
bamboohr_time_create_timesheet_clock_out_entry
Create Timesheet Clock-Out Entry Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
employeeId | integer | Yes | — | ID of the employee to clock out. |
date | string | No | — | Date for the timesheet entry. Must be in YYYY-MM-DD format. |
end | string | No | — | The time for the clock out. In 24 hour format HH:MM |
timezone | string | No | — | The timezone associated with the clock out. |
bamboohr_time_delete_break
Delete Break Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The break ID. |
bamboohr_time_delete_break_policy
Delete Break Policy Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The break policy ID. |
bamboohr_time_delete_timesheet_clock_entries_via_post
Delete Timesheet Clock Entries Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
clockEntryIds | integer[] | Yes | — | Array of clock entry IDs to process |
bamboohr_time_delete_timesheet_hour_entries_via_post
Delete Timesheet Hour Entries Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
hourEntryIds | integer[] | Yes | — | Array of hour entry IDs to process |
bamboohr_time_delete_tracking_hour_record
Delete Hour Record Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The time tracking id is the id that was used to track the record up to 36 characters in length. (i.e. UUID). |
bamboohr_time_get_break
Get Break Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The break ID. |
bamboohr_time_get_break_policy
Get Break Policy Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The break policy ID. |
includeCounts | boolean | No | — | Include employee and break counts |
bamboohr_time_get_off_balance
Get Time Off Balance Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
end | string | No | — | The date to calculate the time off balance as of, in YYYY-MM-DD format. Defaults to company today if not provided. Example: use a future date to project balance. |
precision | integer | No | — | Number of decimal places for balance and usedYearToDate values. Minimum 0, maximum 4. Defaults to 2. |
employeeId | integer | Yes | — | The ID of the employee to get time off balances for. |
bamboohr_time_get_tracking_record
Get Time Tracking Record Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The time tracking record ID used to originally create the record. |
bamboohr_time_list_break_assessments
List Break Assessments Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
offset | integer | No | — | Number of items to skip before returning results. Defaults to 0. |
limit | integer | No | — | Maximum number of items to return. Defaults to 100. Maximum is 500. |
filter | string | No | — | OData v4 filter expression. Filterable fields: id, breakId, employeeId, employeeTimesheetId, date, result, availableYmdt, unavailableYmdt, createdAt, updatedAt, expectedDuration, recordedDuration, durationDifference. |
bamboohr_time_list_break_policies
List Break Policies Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
offset | integer | No | — | The offset of items to retrieve |
limit | integer | No | — | The maximum items to retrieve |
filter | string | No | — | Filter by an OData (Open Data Protocol) v4 specification |
includeCounts | boolean | No | — | Include employee and break counts |
bamboohr_time_list_break_policy_breaks
List Breaks for Break Policy Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The break policy ID. |
offset | integer | No | — | The offset of items to retrieve |
limit | integer | No | — | The maximum items to retrieve |
filter | string | No | — | Filter by an OData (Open Data Protocol) v4 specification |
bamboohr_time_list_break_policy_employees
List Break Policy Employees Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The break policy ID. |
offset | integer | No | — | The offset of items to retrieve |
limit | integer | No | — | The maximum items to retrieve |
bamboohr_time_list_employee_break_availabilities
List Employee Break Availabilities Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | integer | Yes | — | The employee ID. |
effective | string | No | — | The employee’s local time that should be used to calculate availability. Defaults to the current time. Must be in Y-m-d\TH:i:s format (no timezone offset). |
bamboohr_time_list_employee_break_policies
List Employee Break Policies Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | integer | Yes | — | The employee ID. |
offset | integer | No | — | The number of items to skip before starting to collect the result set. Minimum 0. Defaults to 0. |
limit | integer | No | — | The maximum number of items to return. Must be between 0 and 500. Defaults to 100. |
bamboohr_time_list_employee_time_off_policies
List Employee Time Off Policies Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
employeeId | integer | Yes | — | The ID of the employee. |
bamboohr_time_list_employee_time_off_policies_v1_1
List Employee Time Off Policies v1.1 Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
employeeId | integer | Yes | — | The ID of the employee. |
bamboohr_time_list_time_off_policies
List Time Off Policiesbamboohr_time_list_time_off_requests
List Time Off Requests Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | integer | No | — | A particular request ID to limit the response to. |
action | string | No | — | Limit to requests the caller can view, requests they can approve, or only their own requests via myRequests. Defaults to view. |
employeeId | integer | No | — | A particular employee ID to limit the response to. |
start | string | Yes | — | Only include requests that end on or after this date. YYYY-MM-DD format. |
end | string | Yes | — | Only include requests that start on or before this date. YYYY-MM-DD format. |
type | string | No | — | A comma-separated list of time off type IDs to filter by. If omitted, requests of all types are included. |
status | string | No | — | A comma-separated list of request status values to filter by. Accepted values are approved, denied, superceded, requested, and canceled. If omitted, requests of all statuses are included. |
excludeNote | string | No | — | When set to any truthy value, omits the notes object from each request in the response. |
bamboohr_time_list_time_off_types
List Time Off Types Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
mode | string | No | — | Set to request to limit the results to time off types the authenticated employee can request. |
bamboohr_time_list_timesheet_entries
List Timesheet Entries Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
start | string | Yes | — | YYYY-MM-DD. Only show timesheet entries on/after the specified start date. Must be within the last 365 days. |
end | string | Yes | — | YYYY-MM-DD. Only show timesheet entries on/before the specified end date. Must be within the last 365 days. |
employeeIds | string | No | — | A comma separated list of employee IDs. When specified, only entries that match these employee IDs are returned. When omitted, entries for all accessible employees are returned. |
bamboohr_time_list_whos_out
List Who’s Out Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
start | string | No | — | Start date in YYYY-MM-DD format. Defaults to today. |
end | string | No | — | End date in YYYY-MM-DD format. Defaults to 14 days after the start date. |
filter | string | No | — | Set to off to disable the Who’s Out visibility filter and return the unfiltered feed. Any other value leaves filtering enabled. |
bamboohr_time_replace_breaks_for_break_policy
Replace Breaks for Break Policy Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The break policy ID. |
body | object[] | Yes | — | Collection of time tracking breaks to create or update without a policy |
bamboohr_time_set_break_policy_employees
Set Employees for Break Policy Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The break policy ID. |
employeeIds | integer[] | No | — | Array of employee IDs to assign to the break policy. Replaces all existing assignments. |
bamboohr_time_sync_break_policy
Sync Break Policy Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The break policy ID. |
allEmployeesAssigned | boolean | No | — | Whether all employees are assigned to this break policy |
breaks | object[] | No | — | Collection of time tracking breaks to create or update without a policy |
description | string | No | — | Optional description of the break policy |
employeeIds | integer[] | No | — | The employees that should be assigned to this policy |
name | string | No | — | Name of the break policy |
bamboohr_time_unassign_employees_from_break_policy
Unassign Employees from Break Policy Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The break policy ID. |
employeeIds | integer[] | Yes | — | Array of employee IDs to unassign from the break policy |
bamboohr_time_update_break
Update Break Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The break ID. |
availabilityEndTime | string | No | — | Latest time the break can be taken (HH:MM format) |
availabilityMaxHoursWorked | number | No | — | Maximum hours that can be worked before the break must be taken |
availabilityMinHoursWorked | number | No | — | Minimum hours that must be worked before the break can be taken |
availabilityStartTime | string | No | — | Earliest time the break can be taken (HH:MM format) |
availabilityType | object | No | — | When the break is available to be taken |
duration | integer | No | — | Duration of the break in minutes |
name | string | No | — | The name of the break |
paid | boolean | No | — | Whether the break is paid |
policyId | string | No | — | The unique identifier of the break policy this break belongs to |
bamboohr_time_update_break_policy
Update Break Policy Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
id | string | Yes | — | The break policy ID. |
allEmployeesAssigned | boolean | No | — | Whether all employees are assigned to this break policy |
description | string | No | — | Optional description of the break policy |
name | string | No | — | Name of the break policy |
bamboohr_time_update_time_off_request_status
Update Time Off Request Status Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
requestId | integer | Yes | — | The ID of the time off request to update. |
note | string | No | — | A note to attach to the change in status. |
status | string | No | — | The new status for the time off request. |
bamboohr_time_update_time_tracking_record
Update Hour Record Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
holidayId | integer | No | — | ID of the holiday associated with this time tracking record |
hoursWorked | number | No | — | The updated number of hours worked. e.g. if Employee A worked 8.0 hours originally and decided they only worked 6.0, please send 6.0 here not -2.0. |
projectId | integer | No | — | ID of the project associated with this time tracking record |
shiftDifferentialId | integer | No | — | ID of the shift differential associated with this time tracking record |
taskId | integer | No | — | ID of the task associated with this time tracking record |
timeTrackingId | string | No | — | The time tracking id is the id that was used to track the record up to 36 characters in length. (i.e. UUID). |

